Option Explicit
Dim WinVersion As Integer, SoundAvailable As Integer
Global VisibleFrame As Frame

Global Const AppTitle = "Print-2-Image API Demo"
Global Const VBFormClass = "ThunderForm"
Global Const HourglassOn = 11
Global Const HourglassOff = 0


Global Const TWIPS = 1
Global Const PIXELS = 3
Global Const RES_INFO = 2
Global Const MINIMIZED = 1

Type Rect
    Left As Integer
    Top As Integer
    Right As Integer
    Bottom As Integer
End Type

Declare Function GetWindowsDirectory Lib "Kernel" (ByVal P$, ByVal S%) As Integer
Declare Function GetSystemDirectory Lib "kernel" (ByVal P$, ByVal S%) As Integer
Declare Function GetWinFlags Lib "kernel" () As Long
Global Const WF_CPU286 = &H2&
Global Const WF_CPU386 = &H4&
Global Const WF_CPU486 = &H8&
Global Const WF_STANDARD = &H10&
Global Const WF_ENHANCED = &H20&
Global Const WF_80x87 = &H400&

Declare Function GetVersion Lib "Kernel" () As Long
Declare Function GetSystemMetrics Lib "User" (ByVal n As Integer) As Integer
Global Const SM_MOUSEPRESENT = 19

Declare Function GetDeviceCaps Lib "GDI" (ByVal hDC%, ByVal nIndex%) As Integer

Declare Function GlobalCompact Lib "kernel" (ByVal flag&) As Long
Declare Function GetFreeSpace Lib "kernel" (ByVal flag%) As Long
Declare Function GetFreeSystemResources Lib "User" (ByVal fuSysResource As Integer) As Integer
Global Const GFSR_SYSTEMRESOURCES = &H0
Global Const GFSR_GDIRESOURCES = &H1
Global Const GFSR_USERRESOURCES = &H2

Declare Function sndPlaySound Lib "MMSystem" (lpsound As Any, ByVal flag As Integer) As Integer
Declare Function waveOutGetNumDevs Lib "MMSystem" () As Integer

Declare Function TrackPopupMenu Lib "user" (ByVal hMenu%, ByVal wFlags%, ByVal x%, ByVal y%, ByVal r2%, ByVal hWd%, r As Rect) As Integer
Declare Function GetMenu Lib "user" (ByVal hWd%) As Integer
Declare Function GetSubMenu Lib "user" (ByVal hMenu%, ByVal nPos%) As Integer
Declare Function InsertMenu Lib "User" (ByVal hMenu As Integer, ByVal nPosition As Integer, ByVal wFlags As Integer, ByVal wIDNewItem As Integer, ByVal lpNewItem As Any) As Integer
Declare Function GetSystemMenu Lib "User" (ByVal hwnd As Integer, ByVal bRevert As Integer) As Integer
Global Const MF_POPUP = &H10
Global Const MF_BYPOSITION = &H400
Global Const MF_SEPARATOR = &H800

Declare Function GetDeskTopWindow Lib "User" () As Integer
Declare Function GetDC Lib "User" (ByVal hwnd%) As Integer
Declare Sub ReleaseDC Lib "User" (ByVal hwnd%, ByVal hDC%)
Declare Function BitBlt Lib "GDI" (ByVal destDC%, ByVal x%, ByVal y%, ByVal w%, ByVal h%, ByVal srchDC%, ByVal srcX%, ByVal srcY%, ByVal rop&) As Integer
Global Const SRCCOPY = &HCC0020
Global Const SRCERASE = &H440328
Global Const SRCINVERT = &H660046
Global Const SRCAND = &H8800C6

Declare Sub SetWindowPos Lib "User" (ByVal h1%, ByVal h2%, ByVal x%, ByVal y%, ByVal cx%, ByVal cy%, ByVal f%)
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2
Global Const SWP_NOACTIVATE = &H10
Global Const SWP_SHOWWINDOW = &H40

Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function GetProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer) As Integer

Declare Function wu_GetActiveWindow Lib "User" Alias "GetActiveWindow" () As Integer
Declare Function wu_MoveWindow Lib "User" Alias "MoveWindow" (ByVal hwin%, ByVal x%, ByVal y%, ByVal dx%, ByVal dy%, ByVal fRepaint%) As Integer
Declare Function wu_SetFocus Lib "User" Alias "SetFocus" (ByVal hwin%) As Integer
Declare Function wu_ShowWindow Lib "User" Alias "ShowWindow" (ByVal hwnd%, ByVal i%) As Integer
Declare Function wu_GetProfileInt Lib "Kernel" Alias "GetProfileInt" (ByVal lpApprofSection As String, ByVal lprofKeyName As String, ByVal nDefault As Integer) As Integer
Declare Function wu_GetProfileString Lib "Kernel" Alias "GetProfileString" (ByVal lpApprofSection As String, ByVal lprofKeyName As String, ByVal lprofDefString As String, ByVal lRetStringedString As String, ByVal nSize As Integer) As Integer
Declare Function wu_GetPrivateProfileInt Lib "Kernel" Alias "GetPrivateProfileInt" (ByVal lpApplicationName As String, ByVal lprofKeyName As String, ByVal nDefault As Integer, ByVal lpFileName As String) As Integer
Declare Function wu_GetPrivateProfileString Lib "Kernel" Alias "GetPrivateProfileString" (ByVal lpApplicationName As String, ByVal lprofKeyName As Any, ByVal lprofDefString As String, ByVal lRetStringedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function wu_WriteProfileString Lib "Kernel" Alias "WriteProfileString" (ByVal lpApplicationName As String, ByVal lprofKeyName As String, ByVal lpString As String) As Integer
Declare Function wu_WritePrivateProfileString Lib "Kernel" Alias "WritePrivateProfileString" (ByVal lpApplicationName As String, ByVal lprofKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Integer
Declare Function wu_GetWindowsDirectory Lib "Kernel" Alias "GetWindowsDirectory" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer
Declare Function wu_GetSystemDirectory Lib "Kernel" Alias "GetSystemDirectory" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer
Declare Function wu_GetWindowLong Lib "User" Alias "GetWindowLong" (ByVal hwnd%, ByVal i%) As Long
Declare Function wu_SetWindowLong Lib "User" Alias "SetWindowLong" (ByVal hwnd%, ByVal i%, ByVal k&) As Long
Declare Function wu_FindWindow Lib "User" Alias "FindWindow" (ByVal lpClassName As Any, ByVal Cap As Any) As Integer
Declare Function wu_WinExec Lib "Kernel" Alias "WinExec" (ByVal ApplicationName As String, ByVal State As Integer) As Integer
Declare Function wu_SendMessage Lib "User" Alias "SendMessage" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Any) As Long
Declare Function wu_PostMessage Lib "User" Alias "PostMessage" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Any) As Integer

Declare Function wu_GetParent Lib "User" Alias "GetParent" (ByVal hwin%) As Integer
Declare Function wu_GetWindow Lib "User" Alias "GetWindow" (ByVal hw%, ByVal nRelationship%) As Integer
Declare Sub wu_SetWindowText Lib "User" Alias "SetWindowText" (ByVal hwnd%, ByVal lpString$)
Declare Function wu_GetWindowText Lib "User" Alias "GetWindowText" (ByVal hwnd%, ByVal lpString$, ByVal i%) As Integer
Declare Function wu_GetClassName Lib "User" Alias "GetClassName" (ByVal hwin%, ByVal stBuf$, ByVal cch%) As Integer

'
' Constants used in the functions above.
'
Global Const MAX_PATH = 260  '/* max. length of full pathname */
Global Const MAX_DRIVE = 3   ' /* max. length of drive component */
Global Const MAX_DIR = 256    '/* max. length of path component */
Global Const MAX_FNAME = 256 '/* max. length of file name component */
Global Const MAX_EXT = 256   '/* max. length of extension component */


Global Const WM_CLOSE = &H10
Global Const WM_DESTROY = &H2
Global Const WU_SW_RESTORE = 9
Const WU_SW_RESTORE_SQLWIN = 1
Const WU_GW_HWNDFIRST = 0
Const WU_GW_HWNDLAST = 1
Global Const WU_GW_HWNDNEXT = 2
Const WU_GW_HWNDPREV = 3
Const WU_GW_OWNER = 4
Global Const WU_GW_CHILD = 5
Const WU_LOGPIXELSX = 88
Const WU_LOGPIXELSY = 90

Const WU_MF_BYCOMMAND = &H0
Const WU_MF_BYPOSITION = &H400
Const WU_MF_ENABLED = &H0
Const WU_MF_GRAYED = &H1
Const WU_MF_DISABLED = &H2
Const WU_MF_MENUBREAK = &H40
Const WU_MF_CHECKED = &H8
Const WU_MF_UNCHECKED = &H0

'
' Microsoft Access Window Classes.
'
Global Const WU_WC_ACCESS = "OMain"
Global Const WU_WC_ACCESSDBC = "ODb"
Global Const WU_WC_ACCESSTBL = "OTable"
Global Const WU_WC_ACCESSQRY = "OQRY"
Global Const WU_WC_ACCESSFRM = "OForm"
Global Const WU_WC_ACCESSRPT = "OReport"
Global Const WU_WC_ACCESSMAC = "OScript"
Global Const WU_WC_ACCESSMOD = "OModule"
Global Const WU_WC_ACCESSFRMPOPUP = "OFormPopup"
Global Const WU_WC_ACCESSTOOLBAR = "OToolbar"
Global Const WU_WC_ACCESSMDICLIENT = "MDIClient"



Const GWL_STYLE = (-16)

' Window Styles
Const WS_SYSMENU = &H80000
Const WS_MINIMIZEBOX = &H20000
Const WS_MAXIMIZEBOX = &H10000

'Window buttons

Global Const ID_CANCEL = 2
Global Const ID_YES = 6
Global Const ID_NO = 7
Global Const MB_YESNO = 4
Global Const MB_QUESTION = 32
Global Const MB_OK = 0, MB_OKCANCEL = 1    ' Define buttons.
Global Const MB_YESNOCANCEL = 3
Global Const MB_ICONSTOP = 16, MB_ICONQUESTION = 32       ' Define Icons.
Global Const MB_ICONEXCLAMATION = 48, MB_ICONINFORMATION = 64
Global Const MB_DEFBUTTON2 = 256 ' Define other.

'Show Window
Global Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
'#define SW_NORMAL       1
'#define SW_SHOWMINIMIZED    2
Global Const SW_SHOWMAXIMIZED = 3
'#define SW_MAXIMIZE     3
'#define SW_SHOWNOACTIVATE   4
Global Const SW_SHOW = 5
'#define SW_MINIMIZE     6
'#define SW_SHOWMINNOACTIVE  7
'#define SW_SHOWNA       8
'#define SW_RESTORE          9


'DDE_fAck    0x8000
'DDE_fBusy   0x4000
'DDE_fNoData 0x4000
'DDE_fRelease    0x2000
'DDE_fResponse   0x1000



'DDE Messages

'Please refer to the SQLWindows Technical Reference Manual for more information on the use of the
'WM_DDE_* messages.

'Global Const WM_DDE_Ack = &H3E4   '(WM_DDE_First + 4)
'Global Const WM_DDE_Advise = &H3E2   '(WM_DDE_First + 2)
'Global Const WM_DDE_Data = &H3E5  '(WM_DDE_First + 5)
'Global Const WM_DDE_Execute = &H3E8  '(WM_DDE_First + 8)
'Global Const WM_DDE_First = &H3E0
'Global Const WM_DDE_Initiate = &H3E0  '(WM_DDE_First + 0)
'Global Const WM_DDE_Poke = &H3E7  '(WM_DDE_First + 7)
'Global Const WM_DDE_Request = &H3E6   '(WM_DDE_First + 6)
'Global Const WM_DDE_Terminate = &H3E1    '(WM_DDE_First + 1)
'Global Const WM_DDE_Unadvise = &H3E3  '(WM_DDE_First + 3)

'Global Const WM_DROPFILES = &H233
'Global Const WM_KEYDOWN = &H100
Global Const WM_KEYUP = &H101           'YES !!!  P-2-I API type 2
'#define WM_MOUSEMOVE        0x0200
'#define WM_LBUTTONDOWN      0x0201
'#define WM_LBUTTONUP        0x0202
Global Const WM_LBUTTONDBLCLK = &H203   'YES !!!! P-2-I API Type 3
'#define WM_RBUTTONDOWN      0x0204
'#define WM_RBUTTONUP        0x0205
'#define WM_RBUTTONDBLCLK    0x0206
'#define WM_MBUTTONDOWN      0x0207
'#define WM_MBUTTONUP        0x0208
'#define WM_MBUTTONDBLCLK    0x0209

Function DeviceColors (hDC As Integer) As Long
Const PLANES = 14
Const BITSPIXEL = 12
    DeviceColors = GetDeviceCaps(hDC, PLANES) * 2 ^ GetDeviceCaps(hDC, BITSPIXEL)
End Function

Function DosVersion ()
Dim Ver As Long, DosVer As Long
    Ver = GetVersion()
    DosVer = Ver \ &H10000
    DosVersion = Format((DosVer \ 256) + ((DosVer Mod 256) / 100), "Fixed")
End Function

Function GetSysIni (section, key)
Dim retVal As String, AppName As String, worked As Integer
    retVal = String$(255, 0)
    worked = GetPrivateProfileString(section, key, "", retVal, Len(retVal), "System.ini")
    If worked = 0 Then
	GetSysIni = "unknown"
    Else
	GetSysIni = Left(retVal, worked)
    End If
End Function

Function GetWinIni (section, key)
Dim retVal As String, AppName As String, worked As Integer
    retVal = String$(255, 0)
    worked = GetProfileString(section, key, "", retVal, Len(retVal))
    If worked = 0 Then
	GetWinIni = "unknown"
    Else
	GetWinIni = Left(retVal, worked)
    End If
End Function

Function SystemDirectory () As String
Dim WinPath As String
    WinPath = String(145, Chr(0))
    SystemDirectory = Left(WinPath, GetSystemDirectory(WinPath, Len(WinPath)))

End Function

Function WindowsDirectory () As String
Dim WinPath As String
    WinPath = String(145, Chr(0))
    WindowsDirectory = Left(WinPath, GetWindowsDirectory(WinPath, Len(WinPath)))
End Function

Function WindowsVersion ()
Dim Ver As Long, WinVer As Long
    Ver = GetVersion()
    WinVer = Ver And &HFFFF&
    WindowsVersion = Format((WinVer Mod 256) + ((WinVer \ 256) / 100), "Fixed")
End Function

Function wu_GetEntriesInSection (profSection As String, profDefString As String, INIFileName As String) As String
	Dim nSize As Integer
	Dim RetString As String
	Dim CharsReturned As Integer
	Dim xnull As Long

	xnull = 0

	RetString = Space$(2048)
	nSize = 2048

	CharsReturned = wu_GetPrivateProfileString(profSection, xnull, profDefString, RetString, nSize, INIFileName)

	If CharsReturned = 0 Then
		wu_GetEntriesInSection = "error"
		Exit Function
	End If

	wu_GetEntriesInSection = RetString

       
End Function

Function wu_GetPrivateProfile (profSection As String, profKey As String, profDefString As String, INIFileName As String) As String
	Dim nSize As Integer
	Dim RetString As String
	Dim CharsReturned As Integer

	RetString = Space$(100)
	nSize = 100

	CharsReturned = wu_GetPrivateProfileString(profSection, profKey, profDefString, RetString, nSize, INIFileName)

	If CharsReturned = 0 Then
	       wu_GetPrivateProfile = RetString
	       Exit Function
	End If

	RetString = Trim(RetString)
	RetString = Mid(RetString, 1, Len(RetString) - 1)
	wu_GetPrivateProfile = RetString

End Function

'------------------------------------------------------------------------
' FUNCTION    : wu_StWindowClass
'
' PURPOSE     : A simple cover function to the Windows API call.
'------------------------------------------------------------------------
Function wu_StWindowClass (ByVal hwnd As Integer) As String
    
    Const cchMax = 255
    Dim stBuff As String * cchMax
    Dim cch%

    cch% = wu_GetClassName(hwnd, stBuff, cchMax)
    If (hwnd% = 0) Then
	wu_StWindowClass = ""
    Else
	wu_StWindowClass = (Left$(stBuff, cch%))
    End If
End Function

